
if not Global.game_settings then return end
if not Global.game_settings.level_id then return end

if Global.game_settings.level_id ~= "fex" then return end

core:import("CoreMissionScriptElement")

-- log("SUCCESSFULLY HOOKED ELEMENTSPAWNENEMYDUMMY")

AddedFexFixFuxFoxMats = false

function ElementSpawnEnemyDummy:init(...)
	ElementSpawnEnemyDummy.super.init(self, ...)
	
	self._enemy_name = self._values.enemy and Idstring(self._values.enemy) or Idstring("units/payday2/characters/ene_swat_1/ene_swat_1")
	
	local newenemy = nil
	
	-- if self._values.enemy ~= "units/payday2/characters/ene_swat_1/ene_swat_1" then
		-- log("SCRIPTED ENEMY: "..tostring(self._values.enemy))
	-- end
	
	if self._values.enemy == "units/payday2/characters/ene_secret_service_1/ene_secret_service_1" or self._values.enemy == "units/payday2/characters/ene_security_3/ene_security_3" then
		newenemy = "units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex"
	end
	
	if self._values.enemy == "units/payday2/characters/ene_sniper_1/ene_sniper_1" then
		newenemy = "units/pd2_dlc_bex/characters/ene_swat_policia_sniper/ene_swat_policia_sniper"
	end
	
	if self._values.enemy == "units/payday2/characters/ene_swat_heavy_1/ene_swat_heavy_1" or self._values.enemy == "units/payday2/characters/ene_fbi_heavy_1/ene_fbi_heavy_1" then
		newenemy = "units/pd2_dlc_bex/characters/ene_swat_heavy_policia_federale/ene_swat_heavy_policia_federale"
	end
	
	if self._values.enemy == "units/payday2/characters/ene_spook_1/ene_spook_1" then
		newenemy = "units/pd2_dlc_bex/characters/ene_swat_cloaker_policia_federale/ene_swat_cloaker_policia_federale"
	end
	
	if newenemy then
		-- log("REPLACED WITH "..newenemy)
		self._enemy_name = Idstring(newenemy)
	end
	
	if self._values.enemy == "units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex" then self.FexGuard = true end
	
	self._values.enemy = nil
	self._units = {}
	self._events = {}
	
	self:_finalize_values()
	
	if CopBase and not AddedFexFixFuxFoxMats then
		
		AddedFexFixFuxFoxMats = true
		
		local fexmats = {
			"units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex_mat_1",
			"units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex_mat_2",
			"units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex_mat_3",
			"units/pd2_dlc_fex/characters/ene_secret_service_fex/ene_secret_service_fex_mat_4"
		}
		
		for _, fexmat in pairs(fexmats) do
			
			-- See copbase.lua for the original code to this complicated shit
			local mat = Idstring(fexmat)
			local mat_c = Idstring(fexmat .. "_contour")
			
			CopBase._material_translation_map[tostring(mat:key())] = mat_c
			CopBase._material_translation_map[tostring(mat_c:key())] = mat
		end
	end
end

function ElementSpawnEnemyDummy:on_executed(instigator)
	if not self._values.enabled then
		return
	end
	
	if not managers.groupai:state():is_AI_enabled() and not Application:editor() then
		return
	end
	
	local unit = self:produce()
	
	if unit:damage() and self.FexGuard then
		if unit:damage():has_sequence("fex_fux_fox") then
			-- log("RUNNING SEQ")
			unit:damage():run_sequence_simple("fex_fux_fox")
		end
	end
	
	ElementSpawnEnemyDummy.super.on_executed(self, unit)
end
